/**
 * Copyright (c) 2009-2011 Zauber S.A. <http://www.zaubersoftware.com/>
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package ar.com.zauber.commons.mom;

import net.sf.staccatocommons.defs.Applicable;
import net.sf.staccatocommons.defs.Applicable2;
import net.sf.staccatocommons.restrictions.check.NonNull;

public interface MapObjectMapperInterceptor {

    /**
     * @see ar.com.zauber.commons.mom.MapObjectMapper#map(Object)
     * 
     * Then, executes the code that came in the 'proceed' parameter.
     * 
     * @param value
     * @param proceed Code that will be executed.
     * @return
     */
    Object map(Object value, Applicable<Object, Object> proceed);

    /**
     * @see ar.com.zauber.commons.mom.MapObjectMapper#unmap(Object)
     * 
     * Then, executes the code that came in the 'proceed' parameter.
     * 
     * @param map
     * @param proceed Code that will be executed.
     * @return
     */
    Object unamp(Object map, Applicable<Object, Object> proceed);

    /**
     * @see ar.com.zauber.commons.mom.MapObjectMapper#unmap(Object, Class)
     * 
     * Then, executes the code that came in the 'proceed' parameter.
     * 
     * @param value
     * @param type
     * @param proceed Code that will be executed.
     * @return
     */
    Object unmap(Object value, @NonNull Class<?> type, Applicable2<Object, Class<?>, Object> proceed);

}
